/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: DemoApplication                                                                                             */
/* Date:  2015-10-14 15:54                                                                                            */

#include "X2C.h"


/*                                                       Inports                                                      */
/*--------------------------------------------------------------------------------------------------------------------*/
TInports Inports;

/*                                                      Outports                                                      */
/*--------------------------------------------------------------------------------------------------------------------*/
TOutports Outports;

/**********************************************************************************************************************/
/**                                              Global Variables Block                                              **/
/**********************************************************************************************************************/
CONSTANT_FIP16                TAmplitude;
CONSTANT_FIP16                TFrequency;
CONSTANT_FIP16                TLED_off;
CONSTANT_FIP16                TLED_on;
SIN3GEN_FIP16                 TSin3Gen;
CONSTANT_FIP16                TLED;
SINGEN_FIP16                  TSinGen;
AUTOSWITCH_FIP16              TAutoSwitch;
AUTOSWITCH_FIP16              TOscillator__AutoSwitch_001;
I_FIP16                       TOscillator__I_001;
CONSTANT_FIP8                 TOscillator__C_enable_001;
NEGATION_FIP16                TOscillator__Negation_001;
CONSTANT_FIP16                TOscillator__C1_001;
DELAY_FIP16                   TOscillator__Delay_001;
CONSTANT_FIP16                TOscillator__C_init_001;
SCOPE_MAIN                    TScope;

/* Block function table                                                                                               */
#define END_BLOCKFUNCTIONS { (uint16)0, (void (*)(void*))0, (void (*)(void*))0, \
    (uint8 (*)(void*, uint8[]))0, (uint8 (*)(void*, uint8[], uint8))0, (void* (*)(void*, uint16))0 }

const tBlockFunctions blockFunctionTable[] = {
    FUNCTIONS,
    END_BLOCKFUNCTIONS
};

/* Parameter identifier table                                                                                         */
#define END_PARAMETERTABLE { (uint16)0, (void*)0 }

const tParameterTable parameterIdTable[] = {
    PARAMETER_TABLE,
    END_PARAMETERTABLE
};

/**********************************************************************************************************************/
/**                                                  Initialization                                                  **/
/**********************************************************************************************************************/
void X2C_Init()
{
    /******************************************************************************************************************/
    /**                                          Initialize Block Parameters                                         **/
    /******************************************************************************************************************/

    /* Block Amplitude                                                                                                */
    /* Value = 0.5                                                                                                    */
    TAmplitude.K = 16384;

    /* Block Frequency                                                                                                */
    /* Value = 0.0080                                                                                                 */
    TFrequency.K = 262;

    /* Block LEDoff                                                                                                   */
    /* Value = 0.0                                                                                                    */
    TLED_off.K = 0;

    /* Block LEDon                                                                                                    */
    /* Value = 1.0                                                                                                    */
    TLED_on.K = 32767;

    /* Block Sin3Gen                                                                                                  */
    /* fmax = 1000.0                                                                                                  */
    /* Offset = 0.0                                                                                                   */
    /* ts_fact = 1.0                                                                                                  */
    TSin3Gen.delta_phi = 6554;
    TSin3Gen.offset = 0;
    TSin3Gen.phi = 0;

    /* Block LED                                                                                                      */
    /* Value = 0.0                                                                                                    */
    TLED.K = 0;

    /* Block SinGen                                                                                                   */
    /* fmax = 1000.0                                                                                                  */
    /* Offset = 0.0                                                                                                   */
    /* Phase = 0.0                                                                                                    */
    /* ts_fact = 1.0                                                                                                  */
    TSinGen.delta_phi = 6554;
    TSinGen.phase = 0;
    TSinGen.offset = 0;
    TSinGen.phi = 0;

    /* Block AutoSwitch                                                                                               */
    /* Thresh_up = 0.0                                                                                                */
    /* Thresh_down = 0.0                                                                                              */
    TAutoSwitch.Thresh_up = 0;
    TAutoSwitch.Thresh_down = 0;
    TAutoSwitch.Status = 0;

    /* Block Oscillator__AutoSwitch_001                                                                               */
    /* Thresh_up = 0.5                                                                                                */
    /* Thresh_down = -0.5                                                                                             */
    TOscillator__AutoSwitch_001.Thresh_up = 16384;
    TOscillator__AutoSwitch_001.Thresh_down = -16384;
    TOscillator__AutoSwitch_001.Status = 0;

    /* Block Oscillator__I_001                                                                                        */
    /* Ki = 6.05                                                                                                      */
    /* ts_fact = 1.0                                                                                                  */
    TOscillator__I_001.b0 = 20;
    TOscillator__I_001.sfr = 15;
    TOscillator__I_001.i_old = 0;
    TOscillator__I_001.enable_old = 0;

    /* Block Oscillator__C_enable_001                                                                                 */
    /* Value = 1.0                                                                                                    */
    TOscillator__C_enable_001.K = 127;

    /* Block Oscillator__Negation_001                                                                                 */

    /* Block Oscillator__C1_001                                                                                       */
    /* Value = 1.0                                                                                                    */
    TOscillator__C1_001.K = 32767;

    /* Block Oscillator__Delay_001                                                                                    */
    /* ts_fact = 1.0                                                                                                  */

    /* Block Oscillator__C_init_001                                                                                   */
    /* Value = 0.0                                                                                                    */
    TOscillator__C_init_001.K = 0;


    /******************************************************************************************************************/
    /**                                               Link Block Inputs                                              **/
    /******************************************************************************************************************/

    /* Block Amplitude                                                                                                */

    /* Block Frequency                                                                                                */

    /* Block LEDoff                                                                                                   */

    /* Block LEDon                                                                                                    */

    /* Block Sin3Gen                                                                                                  */
    TSin3Gen.A                       = &TAmplitude.Out;
    TSin3Gen.f                       = &TFrequency.Out;

    /* Block LED                                                                                                      */

    /* Block SinGen                                                                                                   */
    TSinGen.A                        = &TAmplitude.Out;
    TSinGen.f                        = &TFrequency.Out;

    /* Block AutoSwitch                                                                                               */
    TAutoSwitch.In1                  = &TLED_off.Out;
    TAutoSwitch.Switch               = &TSinGen.u;
    TAutoSwitch.In3                  = &TLED_on.Out;

    /* Block Oscillator__AutoSwitch_001                                                                               */
    TOscillator__AutoSwitch_001.In1  = &TOscillator__Negation_001.Out;
    TOscillator__AutoSwitch_001.Switch = &TOscillator__I_001.Out;
    TOscillator__AutoSwitch_001.In3  = &TOscillator__C1_001.Out;

    /* Block Oscillator__I_001                                                                                        */
    TOscillator__I_001.In            = &TOscillator__Delay_001.Out;
    TOscillator__I_001.Init          = &TOscillator__C_init_001.Out;
    TOscillator__I_001.Enable        = &TOscillator__C_enable_001.Out;

    /* Block Oscillator__C_enable_001                                                                                 */

    /* Block Oscillator__Negation_001                                                                                 */
    TOscillator__Negation_001.In     = &TOscillator__C1_001.Out;

    /* Block Oscillator__C1_001                                                                                       */

    /* Block Oscillator__Delay_001                                                                                    */
    TOscillator__Delay_001.In        = &TOscillator__AutoSwitch_001.Out;

    /* Block Oscillator__C_init_001                                                                                   */

    /******************************************************************************************************************/
    /**                                                 Link Outports                                                **/
    /******************************************************************************************************************/
    Outports.pLED1                    = &TAutoSwitch.Out;
    Outports.pPIEZO                   = &Inports.ENC;
    Outports.pLED2                    = &Inports.BUTT1;
    Outports.pLED3                    = &TOscillator__Delay_001.Out;
    Outports.pLED4                    = &TLED.Out;

    /******************************************************************************************************************/
    /**                                           Run Block Init Functions                                           **/
    /******************************************************************************************************************/
    Constant_FiP16_Init(&TAmplitude);
    Constant_FiP16_Init(&TFrequency);
    Constant_FiP16_Init(&TLED_off);
    Constant_FiP16_Init(&TLED_on);
    Sin3Gen_FiP16_Init(&TSin3Gen);
    Constant_FiP16_Init(&TLED);
    SinGen_FiP16_Init(&TSinGen);
    AutoSwitch_FiP16_Init(&TAutoSwitch);
    AutoSwitch_FiP16_Init(&TOscillator__AutoSwitch_001);
    I_FiP16_Init(&TOscillator__I_001);
    Constant_FiP8_Init(&TOscillator__C_enable_001);
    Negation_FiP16_Init(&TOscillator__Negation_001);
    Constant_FiP16_Init(&TOscillator__C1_001);
    Delay_FiP16_Init(&TOscillator__Delay_001);
    Constant_FiP16_Init(&TOscillator__C_init_001);
    Scope_Main_Init(&TScope);
}

/**********************************************************************************************************************/
/**                                            Run Block Update Functions                                            **/
/**********************************************************************************************************************/
void X2C_Update(void)
{
    X2C_Update_1();

}

/* X2C_Update for blocks with 1*Ts                                                                                    */
void X2C_Update_1(void)
{
    Delay_FiP16_Update(&TOscillator__Delay_001);
    Negation_FiP16_Update(&TOscillator__Negation_001);
    SinGen_FiP16_Update(&TSinGen);
    AutoSwitch_FiP16_Update(&TAutoSwitch);
    Sin3Gen_FiP16_Update(&TSin3Gen);
    I_FiP16_Update(&TOscillator__I_001);
    AutoSwitch_FiP16_Update(&TOscillator__AutoSwitch_001);
    Scope_Main_Update(&TScope);
}

