/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: foc_closed_loop                                                                                             */
/* Date:  2016-01-22 15:56                                                                                            */

#include "X2C.h"


/*                                                       Inports                                                      */
/*--------------------------------------------------------------------------------------------------------------------*/
TInports Inports;

/*                                                      Outports                                                      */
/*--------------------------------------------------------------------------------------------------------------------*/
TOutports Outports;

/**********************************************************************************************************************/
/**                                              Global Variables Block                                              **/
/**********************************************************************************************************************/
NEGATION_FIP16                TNegation2;
TIMER_INT16                   Ttimer;
CLARK_INV_INT16_ASM           Tclark_inv;
MAXIMUM_FIP16                 TSVM__Maximum1;
MINIMUM_FIP16                 TSVM__Minimum1;
ADD_FIP16                     TSVM__Add;
GAIN_FIP16                    TSVM__Gain3;
MAXIMUM_FIP16                 TSVM__Maximum;
MINIMUM_FIP16                 TSVM__Minimum;
SUB_FIP16                     TSVM__Sub;
SUB_FIP16                     TSVM__Sub1;
GAIN_FIP16                    TSVM__Gain;
GAIN_FIP16                    TSVM__Gain2;
GAIN_FIP16                    TSVM__Gain1;
SUB_FIP16                     TSVM__Sub2;
PARK_INV_INT16_ASM            Tpark_inv;
CLARK_INT16_ASM               Tclark;
PARK_INT16_ASM                Tpark;
CONSTANT_FIP16                TConstant5;
PI_FIP16                      TPI1;
CONSTANT_FIP16                TConstant6;
SUB_FIP16                     TSub4;
NEGATION_FIP16                TNegation3;
PI_FIP16                      TPI2;
SUB_FIP16                     TSub3;
CONSTANT_FIP16                TConstant2;
CONSTANT_FIP16                TConstant3;
SUB_FIP16                     TSub2;
PI_FIP16                      TPI4;
CONSTANT_FIP16                TConstant;
CONSTANT_FIP16                TConstant1;
AUTOSWITCH_FIP16              TAutoSwitch1;
AUTOSWITCH_FIP16              TAutoSwitch;
TYPECONV_FIP16_8              TTypeConv;
RESET_QEI_INT16               Treset_qei;
SCOPE_MAIN                    TScope;

/* Block function table                                                                                               */
#define END_BLOCKFUNCTIONS { (uint16)0, (void (*)(void*))0, (void (*)(void*))0, \
    (uint8 (*)(void*, uint8[]))0, (uint8 (*)(void*, uint8[], uint8))0, (void* (*)(void*, uint16))0 }

const tBlockFunctions blockFunctionTable[] = {
    FUNCTIONS,
    END_BLOCKFUNCTIONS
};

/* Parameter identifier table                                                                                         */
#define END_PARAMETERTABLE { (uint16)0, (void*)0 }

const tParameterTable parameterIdTable[] = {
    PARAMETER_TABLE,
    END_PARAMETERTABLE
};

/**********************************************************************************************************************/
/**                                                  Initialization                                                  **/
/**********************************************************************************************************************/
void X2C_Init()
{
    /******************************************************************************************************************/
    /**                                          Initialize Block Parameters                                         **/
    /******************************************************************************************************************/

    /* Block Negation2                                                                                                */

    /* Block timer                                                                                                    */
    /* ts_fact = 1.0                                                                                                  */
    /* time = 1.0                                                                                                     */
    Ttimer.cnt_val = 0;
    Ttimer.cnt_lim = 20000;

    /* Block clark_inv                                                                                                */

    /* Block SVM__Maximum1                                                                                            */

    /* Block SVM__Minimum1                                                                                            */

    /* Block SVM__Add                                                                                                 */

    /* Block SVM__Gain3                                                                                               */
    /* Gain = 0.5                                                                                                     */
    TSVM__Gain3.V = 16384;
    TSVM__Gain3.sfr = 15;

    /* Block SVM__Maximum                                                                                             */

    /* Block SVM__Minimum                                                                                             */

    /* Block SVM__Sub                                                                                                 */

    /* Block SVM__Sub1                                                                                                */

    /* Block SVM__Gain                                                                                                */
    /* Gain = -1.1                                                                                                    */
    TSVM__Gain.V = -18022;
    TSVM__Gain.sfr = 14;

    /* Block SVM__Gain2                                                                                               */
    /* Gain = -1.1                                                                                                    */
    TSVM__Gain2.V = -18022;
    TSVM__Gain2.sfr = 14;

    /* Block SVM__Gain1                                                                                               */
    /* Gain = -1.1                                                                                                    */
    TSVM__Gain1.V = -18022;
    TSVM__Gain1.sfr = 14;

    /* Block SVM__Sub2                                                                                                */

    /* Block park_inv                                                                                                 */

    /* Block clark                                                                                                    */

    /* Block park                                                                                                     */

    /* Block Constant5                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant5.K = 0;

    /* Block PI1                                                                                                      */
    /* Kp = 12.0                                                                                                      */
    /* Ki = 4.0                                                                                                       */
    /* ts_fact = 1.0                                                                                                  */
    TPI1.b0 = 7;
    TPI1.b1 = 24576;
    TPI1.sfrb0 = 15;
    TPI1.sfrb1 = 11;
    TPI1.i_old = 0;
    TPI1.enable_old = 0;

    /* Block Constant6                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant6.K = 0;

    /* Block Sub4                                                                                                     */

    /* Block Negation3                                                                                                */

    /* Block PI2                                                                                                      */
    /* Kp = 0.5                                                                                                       */
    /* Ki = 2.0                                                                                                       */
    /* ts_fact = 1.0                                                                                                  */
    TPI2.b0 = 3;
    TPI2.b1 = 16384;
    TPI2.sfrb0 = 15;
    TPI2.sfrb1 = 15;
    TPI2.i_old = 0;
    TPI2.enable_old = 0;

    /* Block Sub3                                                                                                     */

    /* Block Constant2                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant2.K = 0;

    /* Block Constant3                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant3.K = 0;

    /* Block Sub2                                                                                                     */

    /* Block PI4                                                                                                      */
    /* Kp = 0.5                                                                                                       */
    /* Ki = 2.0                                                                                                       */
    /* ts_fact = 1.0                                                                                                  */
    TPI4.b0 = 3;
    TPI4.b1 = 16384;
    TPI4.sfrb0 = 15;
    TPI4.sfrb1 = 15;
    TPI4.i_old = 0;
    TPI4.enable_old = 0;

    /* Block Constant                                                                                                 */
    /* Value = 0.6                                                                                                    */
    TConstant.K = 19661;

    /* Block Constant1                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant1.K = 0;

    /* Block AutoSwitch1                                                                                              */
    /* Thresh_up = 0.5                                                                                                */
    /* Thresh_down = 0.0                                                                                              */
    TAutoSwitch1.Thresh_up = 16384;
    TAutoSwitch1.Thresh_down = 0;
    TAutoSwitch1.Status = 0;

    /* Block AutoSwitch                                                                                               */
    /* Thresh_up = 0.5                                                                                                */
    /* Thresh_down = 0.0                                                                                              */
    TAutoSwitch.Thresh_up = 16384;
    TAutoSwitch.Thresh_down = 0;
    TAutoSwitch.Status = 0;

    /* Block TypeConv                                                                                                 */

    /* Block reset_qei                                                                                                */
    Treset_qei.is_reseted = 0;


    /******************************************************************************************************************/
    /**                                               Link Block Inputs                                              **/
    /******************************************************************************************************************/

    /* Block Negation2                                                                                                */
    TNegation2.In                    = &(Inports.qei);

    /* Block timer                                                                                                    */

    /* Block clark_inv                                                                                                */
    Tclark_inv.alpha                 = &TAutoSwitch1.Out;
    Tclark_inv.beta                  = &TAutoSwitch.Out;

    /* Block SVM__Maximum1                                                                                            */
    TSVM__Maximum1.In1               = &Tclark_inv.a;
    TSVM__Maximum1.In2               = &Tclark_inv.b;

    /* Block SVM__Minimum1                                                                                            */
    TSVM__Minimum1.In1               = &TSVM__Minimum.Out;
    TSVM__Minimum1.In2               = &Tclark_inv.c;

    /* Block SVM__Add                                                                                                 */
    TSVM__Add.In1                    = &TSVM__Maximum.Out;
    TSVM__Add.In2                    = &TSVM__Minimum1.Out;

    /* Block SVM__Gain3                                                                                               */
    TSVM__Gain3.In                   = &TSVM__Add.Out;

    /* Block SVM__Maximum                                                                                             */
    TSVM__Maximum.In1                = &TSVM__Maximum1.Out;
    TSVM__Maximum.In2                = &Tclark_inv.c;

    /* Block SVM__Minimum                                                                                             */
    TSVM__Minimum.In1                = &Tclark_inv.a;
    TSVM__Minimum.In2                = &Tclark_inv.b;

    /* Block SVM__Sub                                                                                                 */
    TSVM__Sub.Plus                   = &Tclark_inv.a;
    TSVM__Sub.Minus                  = &TSVM__Gain3.Out;

    /* Block SVM__Sub1                                                                                                */
    TSVM__Sub1.Plus                  = &Tclark_inv.b;
    TSVM__Sub1.Minus                 = &TSVM__Gain3.Out;

    /* Block SVM__Gain                                                                                                */
    TSVM__Gain.In                    = &TSVM__Sub.Out;

    /* Block SVM__Gain2                                                                                               */
    TSVM__Gain2.In                   = &TSVM__Sub1.Out;

    /* Block SVM__Gain1                                                                                               */
    TSVM__Gain1.In                   = &TSVM__Sub2.Out;

    /* Block SVM__Sub2                                                                                                */
    TSVM__Sub2.Plus                  = &Tclark_inv.c;
    TSVM__Sub2.Minus                 = &TSVM__Gain3.Out;

    /* Block park_inv                                                                                                 */
    Tpark_inv.d                      = &TPI2.Out;
    Tpark_inv.q                      = &TPI4.Out;
    Tpark_inv.theta                  = &(Inports.qei);

    /* Block clark                                                                                                    */
    Tclark.a                         = &(Inports.i_a);
    Tclark.b                         = &(Inports.i_b);

    /* Block park                                                                                                     */
    Tpark.alpha                      = &Tclark.alpha;
    Tpark.beta                       = &Tclark.beta;
    Tpark.theta                      = &TNegation2.Out;

    /* Block Constant5                                                                                                */

    /* Block PI1                                                                                                      */
    TPI1.In                          = &TSub2.Out;
    TPI1.Init                        = &TConstant3.Out;
    TPI1.Enable                      = &TTypeConv.Out;

    /* Block Constant6                                                                                                */

    /* Block Sub4                                                                                                     */
    TSub4.Plus                       = &TConstant5.Out;
    TSub4.Minus                      = &Tpark.d;

    /* Block Negation3                                                                                                */
    TNegation3.In                    = &Tpark.q;

    /* Block PI2                                                                                                      */
    TPI2.In                          = &TSub4.Out;
    TPI2.Init                        = &TConstant2.Out;
    TPI2.Enable                      = &TTypeConv.Out;

    /* Block Sub3                                                                                                     */
    TSub3.Plus                       = &TPI1.Out;
    TSub3.Minus                      = &TNegation3.Out;

    /* Block Constant2                                                                                                */

    /* Block Constant3                                                                                                */

    /* Block Sub2                                                                                                     */
    TSub2.Plus                       = &(Inports.omega_set);
    TSub2.Minus                      = &(Inports.omega_meas);

    /* Block PI4                                                                                                      */
    TPI4.In                          = &TSub3.Out;
    TPI4.Init                        = &TConstant6.Out;
    TPI4.Enable                      = &TTypeConv.Out;

    /* Block Constant                                                                                                 */

    /* Block Constant1                                                                                                */

    /* Block AutoSwitch1                                                                                              */
    TAutoSwitch1.In1                 = &Tpark_inv.alpha;
    TAutoSwitch1.Switch              = &Ttimer.out;
    TAutoSwitch1.In3                 = &TConstant.Out;

    /* Block AutoSwitch                                                                                               */
    TAutoSwitch.In1                  = &Tpark_inv.beta;
    TAutoSwitch.Switch               = &Ttimer.out;
    TAutoSwitch.In3                  = &TConstant1.Out;

    /* Block TypeConv                                                                                                 */
    TTypeConv.In                     = &Ttimer.out;

    /* Block reset_qei                                                                                                */
    Treset_qei.enable                = &Ttimer.out;

    /******************************************************************************************************************/
    /**                                                 Link Outports                                                **/
    /******************************************************************************************************************/
    Outports.pPWM1                    = &TSVM__Gain.Out;
    Outports.pPWM2                    = &TSVM__Gain2.Out;
    Outports.pPWM3                    = &TSVM__Gain1.Out;

    /******************************************************************************************************************/
    /**                                           Run Block Init Functions                                           **/
    /******************************************************************************************************************/
    Negation_FiP16_Init(&TNegation2);
    timer_INT16_Init(&Ttimer);
    clark_inv_INT16_ASM_Init(&Tclark_inv);
    Maximum_FiP16_Init(&TSVM__Maximum1);
    Minimum_FiP16_Init(&TSVM__Minimum1);
    Add_FiP16_Init(&TSVM__Add);
    Gain_FiP16_Init(&TSVM__Gain3);
    Maximum_FiP16_Init(&TSVM__Maximum);
    Minimum_FiP16_Init(&TSVM__Minimum);
    Sub_FiP16_Init(&TSVM__Sub);
    Sub_FiP16_Init(&TSVM__Sub1);
    Gain_FiP16_Init(&TSVM__Gain);
    Gain_FiP16_Init(&TSVM__Gain2);
    Gain_FiP16_Init(&TSVM__Gain1);
    Sub_FiP16_Init(&TSVM__Sub2);
    park_inv_INT16_ASM_Init(&Tpark_inv);
    clark_INT16_ASM_Init(&Tclark);
    park_INT16_ASM_Init(&Tpark);
    Constant_FiP16_Init(&TConstant5);
    PI_FiP16_Init(&TPI1);
    Constant_FiP16_Init(&TConstant6);
    Sub_FiP16_Init(&TSub4);
    Negation_FiP16_Init(&TNegation3);
    PI_FiP16_Init(&TPI2);
    Sub_FiP16_Init(&TSub3);
    Constant_FiP16_Init(&TConstant2);
    Constant_FiP16_Init(&TConstant3);
    Sub_FiP16_Init(&TSub2);
    PI_FiP16_Init(&TPI4);
    Constant_FiP16_Init(&TConstant);
    Constant_FiP16_Init(&TConstant1);
    AutoSwitch_FiP16_Init(&TAutoSwitch1);
    AutoSwitch_FiP16_Init(&TAutoSwitch);
    TypeConv_FiP16_8_Init(&TTypeConv);
    reset_qei_INT16_Init(&Treset_qei);
    Scope_Main_Init(&TScope);
}

/**********************************************************************************************************************/
/**                                            Run Block Update Functions                                            **/
/**********************************************************************************************************************/
void X2C_Update(void)
{
    X2C_Update_1();

}

/* X2C_Update for blocks with 1*Ts                                                                                    */
void X2C_Update_1(void)
{
    Negation_FiP16_Update(&TNegation2);
    Sub_FiP16_Update(&TSub2);
    clark_INT16_ASM_Update(&Tclark);
    park_INT16_ASM_Update(&Tpark);
    timer_INT16_Update(&Ttimer);
    Negation_FiP16_Update(&TNegation3);
    Sub_FiP16_Update(&TSub4);
    TypeConv_FiP16_8_Update(&TTypeConv);
    PI_FiP16_Update(&TPI1);
    PI_FiP16_Update(&TPI2);
    Sub_FiP16_Update(&TSub3);
    PI_FiP16_Update(&TPI4);
    park_inv_INT16_ASM_Update(&Tpark_inv);
    AutoSwitch_FiP16_Update(&TAutoSwitch);
    AutoSwitch_FiP16_Update(&TAutoSwitch1);
    clark_inv_INT16_ASM_Update(&Tclark_inv);
    Maximum_FiP16_Update(&TSVM__Maximum1);
    Minimum_FiP16_Update(&TSVM__Minimum);
    reset_qei_INT16_Update(&Treset_qei);
    Maximum_FiP16_Update(&TSVM__Maximum);
    Minimum_FiP16_Update(&TSVM__Minimum1);
    Add_FiP16_Update(&TSVM__Add);
    Gain_FiP16_Update(&TSVM__Gain3);
    Sub_FiP16_Update(&TSVM__Sub);
    Sub_FiP16_Update(&TSVM__Sub1);
    Sub_FiP16_Update(&TSVM__Sub2);
    Gain_FiP16_Update(&TSVM__Gain);
    Gain_FiP16_Update(&TSVM__Gain1);
    Gain_FiP16_Update(&TSVM__Gain2);
    Scope_Main_Update(&TScope);
}

