/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: foc_closed_loop_pos                                                                                         */
/* Date:  2016-01-22 14:21                                                                                            */

#include "Target.h"
#include "X2C.h"
#include "X2CSignals.h"

extern AUTOSWITCH_FIP16 TAutoSwitch;
extern AUTOSWITCH_FIP16 TAutoSwitch1;
extern AVERAGE_FIP16 TAverage;
extern AVERAGE_FIP16 TAverage1;
extern CONSTANT_FIP16 TConstant;
extern CONSTANT_FIP16 TConstant1;
extern CONSTANT_FIP16 TConstant2;
extern CONSTANT_FIP16 TConstant3;
extern CONSTANT_FIP16 TConstant5;
extern CONSTANT_FIP16 TConstant6;
extern CONSTANT_FIP16 TConstant7;
extern NEGATION_FIP16 TNegation1;
extern NEGATION_FIP16 TNegation2;
extern PI_FIP16 TPI1;
extern PI_FIP16 TPI2;
extern PI_FIP16 TPI3;
extern PI_FIP16 TPI4;
extern ADD_FIP16 TSVM__Add;
extern GAIN_FIP16 TSVM__Gain;
extern GAIN_FIP16 TSVM__Gain1;
extern GAIN_FIP16 TSVM__Gain2;
extern GAIN_FIP16 TSVM__Gain3;
extern MAXIMUM_FIP16 TSVM__Maximum;
extern MAXIMUM_FIP16 TSVM__Maximum1;
extern MINIMUM_FIP16 TSVM__Minimum;
extern MINIMUM_FIP16 TSVM__Minimum1;
extern SUB_FIP16 TSVM__Sub;
extern SUB_FIP16 TSVM__Sub1;
extern SUB_FIP16 TSVM__Sub2;
extern SUB_FIP16 TSub1;
extern SUB_FIP16 TSub2;
extern SUB_FIP16 TSub3;
extern SUB_FIP16 TSub4;
extern TYPECONV_FIP16_8 TTypeConv;
extern CLARK_INT16_ASM Tclark;
extern CLARK_INV_INT16_ASM Tclark_inv;
extern PARK_INT16_ASM Tpark;
extern PARK_INV_INT16_ASM Tpark_inv;
extern RESET_QEI_INT16 Treset_qei;
extern TIMER_INT16 Ttimer;

const X2cSignal inportSignals[] = {
   { "i_a", &Inports.i_a, TYPE_INT16 },
   { "i_b", &Inports.i_b, TYPE_INT16 },
   { "omega_meas", &Inports.omega_meas, TYPE_INT16 },
   { "pos_meas", &Inports.pos_meas, TYPE_INT16 },
   { "pos_set", &Inports.pos_set, TYPE_INT16 },
   { "qei", &Inports.qei, TYPE_INT16 },
};
const uint16 noInportSignals = sizeof(inportSignals) / sizeof(X2cSignal);

const X2cSignal outportSignals[] = {
   { "PWM1", &Outports.pPWM1, TYPE_INT16},
   { "PWM2", &Outports.pPWM2, TYPE_INT16},
   { "PWM3", &Outports.pPWM3, TYPE_INT16},
};
const uint16 noOutportSignals = sizeof(outportSignals) / sizeof(X2cSignal);

const X2cSignal internalSignals[] = {
   { "AutoSwitch.Out", &TAutoSwitch.Out, TYPE_INT16 },
   { "AutoSwitch1.Out", &TAutoSwitch1.Out, TYPE_INT16 },
   { "Average.Out", &TAverage.Out, TYPE_INT16 },
   { "Average1.Out", &TAverage1.Out, TYPE_INT16 },
   { "Constant.Out", &TConstant.Out, TYPE_INT16 },
   { "Constant1.Out", &TConstant1.Out, TYPE_INT16 },
   { "Constant2.Out", &TConstant2.Out, TYPE_INT16 },
   { "Constant3.Out", &TConstant3.Out, TYPE_INT16 },
   { "Constant5.Out", &TConstant5.Out, TYPE_INT16 },
   { "Constant6.Out", &TConstant6.Out, TYPE_INT16 },
   { "Constant7.Out", &TConstant7.Out, TYPE_INT16 },
   { "Negation1.Out", &TNegation1.Out, TYPE_INT16 },
   { "Negation2.Out", &TNegation2.Out, TYPE_INT16 },
   { "PI1.Out", &TPI1.Out, TYPE_INT16 },
   { "PI2.Out", &TPI2.Out, TYPE_INT16 },
   { "PI3.Out", &TPI3.Out, TYPE_INT16 },
   { "PI4.Out", &TPI4.Out, TYPE_INT16 },
   { "SVM__Add.Out", &TSVM__Add.Out, TYPE_INT16 },
   { "SVM__Gain.Out", &TSVM__Gain.Out, TYPE_INT16 },
   { "SVM__Gain1.Out", &TSVM__Gain1.Out, TYPE_INT16 },
   { "SVM__Gain2.Out", &TSVM__Gain2.Out, TYPE_INT16 },
   { "SVM__Gain3.Out", &TSVM__Gain3.Out, TYPE_INT16 },
   { "SVM__Maximum.Out", &TSVM__Maximum.Out, TYPE_INT16 },
   { "SVM__Maximum1.Out", &TSVM__Maximum1.Out, TYPE_INT16 },
   { "SVM__Minimum.Out", &TSVM__Minimum.Out, TYPE_INT16 },
   { "SVM__Minimum1.Out", &TSVM__Minimum1.Out, TYPE_INT16 },
   { "SVM__Sub.Out", &TSVM__Sub.Out, TYPE_INT16 },
   { "SVM__Sub1.Out", &TSVM__Sub1.Out, TYPE_INT16 },
   { "SVM__Sub2.Out", &TSVM__Sub2.Out, TYPE_INT16 },
   { "Sub1.Out", &TSub1.Out, TYPE_INT16 },
   { "Sub2.Out", &TSub2.Out, TYPE_INT16 },
   { "Sub3.Out", &TSub3.Out, TYPE_INT16 },
   { "Sub4.Out", &TSub4.Out, TYPE_INT16 },
   { "TypeConv.Out", &TTypeConv.Out, TYPE_INT8 },
   { "clark.alpha", &Tclark.alpha, TYPE_INT16 },
   { "clark.beta", &Tclark.beta, TYPE_INT16 },
   { "clark_inv.a", &Tclark_inv.a, TYPE_INT16 },
   { "clark_inv.b", &Tclark_inv.b, TYPE_INT16 },
   { "clark_inv.c", &Tclark_inv.c, TYPE_INT16 },
   { "park.d", &Tpark.d, TYPE_INT16 },
   { "park.q", &Tpark.q, TYPE_INT16 },
   { "park_inv.alpha", &Tpark_inv.alpha, TYPE_INT16 },
   { "park_inv.beta", &Tpark_inv.beta, TYPE_INT16 },
   { "timer.out", &Ttimer.out, TYPE_INT16 },
};
const uint16 noInternalSignals = sizeof(internalSignals) / sizeof(X2cSignal);
