/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: foc_open_loop                                                                                               */
/* Date:  2016-01-26 16:19                                                                                            */

#include "X2C.h"


/*                                                       Inports                                                      */
/*--------------------------------------------------------------------------------------------------------------------*/
TInports Inports;

/*                                                      Outports                                                      */
/*--------------------------------------------------------------------------------------------------------------------*/
TOutports Outports;

/**********************************************************************************************************************/
/**                                              Global Variables Block                                              **/
/**********************************************************************************************************************/
CLARK_INV_INT16_ASM           Tclark_inv;
CONSTANT_FIP16                TConstant;
AUTOSWITCH_FIP16              TAutoSwitch;
TIMER_INT16                   Ttimer;
CLARK_INT16_ASM               Tclark;
CONSTANT_FIP16                TConstant1;
LIMITATION_FIP16              TLimitation;
SAWTOOTH_INT16                Tsawtooth;
PARK_INT16_ASM                Tpark;
CONSTANT_FIP16                TConstant2;
CONSTANT_FIP16                TConstant3;
NEGATION_FIP16                TNegation;
RESET_QEI_INT16               Treset_qei;
AUTOSWITCH_FIP16              TAutoSwitch1;
PARK_INV_INT16_ASM            Tpark_inv;
CONSTANT_FIP16                TConstant5;
SCOPE_MAIN                    TScope;

/* Block function table                                                                                               */
#define END_BLOCKFUNCTIONS { (uint16)0, (void (*)(void*))0, (void (*)(void*))0, \
    (uint8 (*)(void*, uint8[]))0, (uint8 (*)(void*, uint8[], uint8))0, (void* (*)(void*, uint16))0 }

const tBlockFunctions blockFunctionTable[] = {
    FUNCTIONS,
    END_BLOCKFUNCTIONS
};

/* Parameter identifier table                                                                                         */
#define END_PARAMETERTABLE { (uint16)0, (void*)0 }

const tParameterTable parameterIdTable[] = {
    PARAMETER_TABLE,
    END_PARAMETERTABLE
};

/**********************************************************************************************************************/
/**                                                  Initialization                                                  **/
/**********************************************************************************************************************/
void X2C_Init()
{
    /******************************************************************************************************************/
    /**                                          Initialize Block Parameters                                         **/
    /******************************************************************************************************************/

    /* Block clark_inv                                                                                                */

    /* Block Constant                                                                                                 */
    /* Value = 0.6                                                                                                    */
    TConstant.K = 19661;

    /* Block AutoSwitch                                                                                               */
    /* Thresh_up = 0.5                                                                                                */
    /* Thresh_down = 0.0                                                                                              */
    TAutoSwitch.Thresh_up = 16384;
    TAutoSwitch.Thresh_down = 0;
    TAutoSwitch.Status = 0;

    /* Block timer                                                                                                    */
    /* ts_fact = 1.0                                                                                                  */
    /* time = 1.0                                                                                                     */
    Ttimer.cnt_val = 0;
    Ttimer.cnt_lim = 20000;

    /* Block clark                                                                                                    */

    /* Block Constant1                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant1.K = 0;

    /* Block Limitation                                                                                               */

    /* Block sawtooth                                                                                                 */
    /* ts_fact = 1.0                                                                                                  */
    /* time = 1.5                                                                                                     */
    Tsawtooth.time_ctr = 30000;
    Tsawtooth.cnt_dir = 1;
    Tsawtooth.add = 1;
    Tsawtooth.cnt_val = 0;

    /* Block park                                                                                                     */

    /* Block Constant2                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant2.K = 0;

    /* Block Constant3                                                                                                */
    /* Value = 0.7                                                                                                    */
    TConstant3.K = 22938;

    /* Block Negation                                                                                                 */

    /* Block reset_qei                                                                                                */
    Treset_qei.is_reseted = 0;

    /* Block AutoSwitch1                                                                                              */
    /* Thresh_up = 0.5                                                                                                */
    /* Thresh_down = 0.0                                                                                              */
    TAutoSwitch1.Thresh_up = 16384;
    TAutoSwitch1.Thresh_down = 0;
    TAutoSwitch1.Status = 0;

    /* Block park_inv                                                                                                 */

    /* Block Constant5                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant5.K = 0;


    /******************************************************************************************************************/
    /**                                               Link Block Inputs                                              **/
    /******************************************************************************************************************/

    /* Block clark_inv                                                                                                */
    Tclark_inv.alpha                 = &TAutoSwitch1.Out;
    Tclark_inv.beta                  = &TAutoSwitch.Out;

    /* Block Constant                                                                                                 */

    /* Block AutoSwitch                                                                                               */
    TAutoSwitch.In1                  = &Tpark_inv.beta;
    TAutoSwitch.Switch               = &Ttimer.out;
    TAutoSwitch.In3                  = &TConstant1.Out;

    /* Block timer                                                                                                    */

    /* Block clark                                                                                                    */
    Tclark.a                         = &(Inports.i_a);
    Tclark.b                         = &(Inports.i_b);

    /* Block Constant1                                                                                                */

    /* Block Limitation                                                                                               */
    TLimitation.In                   = &Tsawtooth.out;
    TLimitation.max                  = &TConstant3.Out;
    TLimitation.min                  = &TConstant2.Out;

    /* Block sawtooth                                                                                                 */
    Tsawtooth.enable                 = &Ttimer.out;

    /* Block park                                                                                                     */
    Tpark.alpha                      = &Tclark.alpha;
    Tpark.beta                       = &Tclark.beta;
    Tpark.theta                      = &TNegation.Out;

    /* Block Constant2                                                                                                */

    /* Block Constant3                                                                                                */

    /* Block Negation                                                                                                 */
    TNegation.In                     = &(Inports.Inport);

    /* Block reset_qei                                                                                                */
    Treset_qei.enable                = &Ttimer.out;

    /* Block AutoSwitch1                                                                                              */
    TAutoSwitch1.In1                 = &Tpark_inv.alpha;
    TAutoSwitch1.Switch              = &Ttimer.out;
    TAutoSwitch1.In3                 = &TConstant.Out;

    /* Block park_inv                                                                                                 */
    Tpark_inv.d                      = &TConstant5.Out;
    Tpark_inv.q                      = &TLimitation.Out;
    Tpark_inv.theta                  = &(Inports.Inport);

    /* Block Constant5                                                                                                */

    /******************************************************************************************************************/
    /**                                                 Link Outports                                                **/
    /******************************************************************************************************************/
    Outports.pOutport                 = &Tclark_inv.a;
    Outports.pOutport1                = &Tclark_inv.b;
    Outports.pdebug_i_alpha           = &Tclark.alpha;
    Outports.pOutport2                = &Tclark_inv.c;
    Outports.pdebug_i_beta            = &Tclark.beta;
    Outports.pdebug_id                = &Tpark.d;
    Outports.pdebug_iq                = &Tpark.q;

    /******************************************************************************************************************/
    /**                                           Run Block Init Functions                                           **/
    /******************************************************************************************************************/
    clark_inv_INT16_ASM_Init(&Tclark_inv);
    Constant_FiP16_Init(&TConstant);
    AutoSwitch_FiP16_Init(&TAutoSwitch);
    timer_INT16_Init(&Ttimer);
    clark_INT16_ASM_Init(&Tclark);
    Constant_FiP16_Init(&TConstant1);
    Limitation_FiP16_Init(&TLimitation);
    sawtooth_INT16_Init(&Tsawtooth);
    park_INT16_ASM_Init(&Tpark);
    Constant_FiP16_Init(&TConstant2);
    Constant_FiP16_Init(&TConstant3);
    Negation_FiP16_Init(&TNegation);
    reset_qei_INT16_Init(&Treset_qei);
    AutoSwitch_FiP16_Init(&TAutoSwitch1);
    park_inv_INT16_ASM_Init(&Tpark_inv);
    Constant_FiP16_Init(&TConstant5);
    Scope_Main_Init(&TScope);
}

/**********************************************************************************************************************/
/**                                            Run Block Update Functions                                            **/
/**********************************************************************************************************************/
void X2C_Update(void)
{
    X2C_Update_1();

}

/* X2C_Update for blocks with 1*Ts                                                                                    */
void X2C_Update_1(void)
{
    timer_INT16_Update(&Ttimer);
    sawtooth_INT16_Update(&Tsawtooth);
    Limitation_FiP16_Update(&TLimitation);
    park_inv_INT16_ASM_Update(&Tpark_inv);
    AutoSwitch_FiP16_Update(&TAutoSwitch);
    AutoSwitch_FiP16_Update(&TAutoSwitch1);
    Negation_FiP16_Update(&TNegation);
    clark_INT16_ASM_Update(&Tclark);
    clark_inv_INT16_ASM_Update(&Tclark_inv);
    park_INT16_ASM_Update(&Tpark);
    reset_qei_INT16_Update(&Treset_qei);
    Scope_Main_Update(&TScope);
}

