/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: foc_open_loop                                                                                               */
/* Date:  2016-01-26 16:19                                                                                            */

#ifndef __X2C_H__
#define __X2C_H__

/**********************************************************************************************************************/
/**     Includes                                                                                                     **/
/**********************************************************************************************************************/
#include "clark_inv_INT16_ASM.h"
#include "Constant_FiP16.h"
#include "AutoSwitch_FiP16.h"
#include "timer_INT16.h"
#include "clark_INT16_ASM.h"
#include "Limitation_FiP16.h"
#include "sawtooth_INT16.h"
#include "park_INT16_ASM.h"
#include "Negation_FiP16.h"
#include "reset_qei_INT16.h"
#include "park_inv_INT16_ASM.h"
#include "Scope_Main.h"
#include "CommonFcts.h"

/**********************************************************************************************************************/
/**     Defines                                                                                                      **/
/**********************************************************************************************************************/
#define FUNCTIONS CLARK_INV_INT16_ASM_FUNCTIONS , \
                  CONSTANT_FIP16_FUNCTIONS , \
                  AUTOSWITCH_FIP16_FUNCTIONS , \
                  TIMER_INT16_FUNCTIONS , \
                  CLARK_INT16_ASM_FUNCTIONS , \
                  LIMITATION_FIP16_FUNCTIONS , \
                  SAWTOOTH_INT16_FUNCTIONS , \
                  PARK_INT16_ASM_FUNCTIONS , \
                  NEGATION_FIP16_FUNCTIONS , \
                  RESET_QEI_INT16_FUNCTIONS , \
                  PARK_INV_INT16_ASM_FUNCTIONS , \
                  SCOPE_MAIN_FUNCTIONS 

#define PARAMETER_TABLE { (uint16)1, &TAutoSwitch } , \
                        { (uint16)2, &TAutoSwitch1 } , \
                        { (uint16)3, &TConstant } , \
                        { (uint16)4, &TConstant1 } , \
                        { (uint16)5, &TConstant2 } , \
                        { (uint16)6, &TConstant3 } , \
                        { (uint16)7, &TConstant5 } , \
                        { (uint16)8, &TLimitation } , \
                        { (uint16)9, &TNegation } , \
                        { (uint16)10, &Tclark } , \
                        { (uint16)11, &Tclark_inv } , \
                        { (uint16)12, &Tpark } , \
                        { (uint16)13, &Tpark_inv } , \
                        { (uint16)14, &Treset_qei } , \
                        { (uint16)15, &Tsawtooth } , \
                        { (uint16)16, &Ttimer } , \
                        { (uint16)17, &TScope } , \
                        { (uint16)18, &Inports.Inport } , \
                        { (uint16)19, &Inports.i_a } , \
                        { (uint16)20, &Inports.i_b } , \
                        { (uint16)21, &Outports.pOutport } , \
                        { (uint16)22, &Outports.pOutport1 } , \
                        { (uint16)23, &Outports.pdebug_i_alpha } , \
                        { (uint16)24, &Outports.pOutport2 } , \
                        { (uint16)25, &Outports.pdebug_i_beta } , \
                        { (uint16)26, &Outports.pdebug_id } , \
                        { (uint16)27, &Outports.pdebug_iq } 

/**********************************************************************************************************************/
/**     Typdefs                                                                                                      **/
/**********************************************************************************************************************/

/* Inport structure                                                                                                   */
typedef struct 
{
    int16 Inport;
    int16 i_a;
    int16 i_b;
} TInports;

/* Outport structure                                                                                                  */
typedef struct 
{
    int16* pOutport;
    int16* pOutport1;
    int16* pdebug_i_alpha;
    int16* pOutport2;
    int16* pdebug_i_beta;
    int16* pdebug_id;
    int16* pdebug_iq;
} TOutports;

/**********************************************************************************************************************/
/**     Externals                                                                                                    **/
/**********************************************************************************************************************/
extern TInports Inports;
extern TOutports Outports;
extern const tBlockFunctions blockFunctionTable[];
extern const tParameterTable parameterIdTable[];


/**********************************************************************************************************************/
/**     Prototypes                                                                                                   **/
/**********************************************************************************************************************/
void X2C_Init(void);
void X2C_Update(void);
void X2C_Update_1(void);


#endif
