/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: foc_open_loop_v3                                                                                            */
/* Date:  2016-01-14 17:02                                                                                            */

#include "X2C.h"


/*                                                       Inports                                                      */
/*--------------------------------------------------------------------------------------------------------------------*/
TInports Inports;

/*                                                      Outports                                                      */
/*--------------------------------------------------------------------------------------------------------------------*/
TOutports Outports;

/**********************************************************************************************************************/
/**                                              Global Variables Block                                              **/
/**********************************************************************************************************************/
CONSTANT_FIP16                TConstant;
AUTOSWITCH_FIP16              TAutoSwitch;
TIMER_INT16                   Ttimer;
CLARK_INT16_ASM               Tclark;
CONSTANT_FIP16                TConstant1;
PARK_INT16_ASM                Tpark;
RESET_QEI_INT16               Treset_qei;
AUTOSWITCH_FIP16              TAutoSwitch1;
PARK_INV_INT16_ASM            Tpark_inv;
CONSTANT_FIP16                TConstant5;
CLARK_INV_INT16_ASM           Tclark_inv;
NEGATION_FIP16                TNegation;
CONSTANT_FIP16                TConstant6;
MAXIMUM_FIP16                 TSVM__Maximum;
GAIN_FIP16                    TSVM__Gain;
GAIN_FIP16                    TSVM__Gain1;
ADD_FIP16                     TSVM__Add;
GAIN_FIP16                    TSVM__Gain2;
GAIN_FIP16                    TSVM__Gain3;
MAXIMUM_FIP16                 TSVM__Maximum1;
MINIMUM_FIP16                 TSVM__Minimum;
SUB_FIP16                     TSVM__Sub;
SUB_FIP16                     TSVM__Sub1;
SUB_FIP16                     TSVM__Sub2;
MINIMUM_FIP16                 TSVM__Minimum1;
SCOPE_MAIN                    TScope;

/* Block function table                                                                                               */
#define END_BLOCKFUNCTIONS { (uint16)0, (void (*)(void*))0, (void (*)(void*))0, \
    (uint8 (*)(void*, uint8[]))0, (uint8 (*)(void*, uint8[], uint8))0, (void* (*)(void*, uint16))0 }

const tBlockFunctions blockFunctionTable[] = {
    FUNCTIONS,
    END_BLOCKFUNCTIONS
};

/* Parameter identifier table                                                                                         */
#define END_PARAMETERTABLE { (uint16)0, (void*)0 }

const tParameterTable parameterIdTable[] = {
    PARAMETER_TABLE,
    END_PARAMETERTABLE
};

/**********************************************************************************************************************/
/**                                                  Initialization                                                  **/
/**********************************************************************************************************************/
void X2C_Init()
{
    /******************************************************************************************************************/
    /**                                          Initialize Block Parameters                                         **/
    /******************************************************************************************************************/

    /* Block Constant                                                                                                 */
    /* Value = 0.5                                                                                                    */
    TConstant.K = 16384;

    /* Block AutoSwitch                                                                                               */
    /* Thresh_up = 0.5                                                                                                */
    /* Thresh_down = 0.0                                                                                              */
    TAutoSwitch.Thresh_up = 16384;
    TAutoSwitch.Thresh_down = 0;
    TAutoSwitch.Status = 0;

    /* Block timer                                                                                                    */
    /* ts_fact = 1.0                                                                                                  */
    /* time = 1.0                                                                                                     */
    Ttimer.cnt_val = 0;
    Ttimer.cnt_lim = 20000;

    /* Block clark                                                                                                    */

    /* Block Constant1                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant1.K = 0;

    /* Block park                                                                                                     */

    /* Block reset_qei                                                                                                */
    Treset_qei.is_reseted = 0;

    /* Block AutoSwitch1                                                                                              */
    /* Thresh_up = 0.5                                                                                                */
    /* Thresh_down = 0.0                                                                                              */
    TAutoSwitch1.Thresh_up = 16384;
    TAutoSwitch1.Thresh_down = 0;
    TAutoSwitch1.Status = 0;

    /* Block park_inv                                                                                                 */

    /* Block Constant5                                                                                                */
    /* Value = 0.8                                                                                                    */
    TConstant5.K = 26214;

    /* Block clark_inv                                                                                                */

    /* Block Negation                                                                                                 */

    /* Block Constant6                                                                                                */
    /* Value = 0.0                                                                                                    */
    TConstant6.K = 0;

    /* Block SVM__Maximum                                                                                             */

    /* Block SVM__Gain                                                                                                */
    /* Gain = -1.1                                                                                                    */
    TSVM__Gain.V = -18022;
    TSVM__Gain.sfr = 14;

    /* Block SVM__Gain1                                                                                               */
    /* Gain = -1.1                                                                                                    */
    TSVM__Gain1.V = -18022;
    TSVM__Gain1.sfr = 14;

    /* Block SVM__Add                                                                                                 */

    /* Block SVM__Gain2                                                                                               */
    /* Gain = -1.1                                                                                                    */
    TSVM__Gain2.V = -18022;
    TSVM__Gain2.sfr = 14;

    /* Block SVM__Gain3                                                                                               */
    /* Gain = 0.5                                                                                                     */
    TSVM__Gain3.V = 16384;
    TSVM__Gain3.sfr = 15;

    /* Block SVM__Maximum1                                                                                            */

    /* Block SVM__Minimum                                                                                             */

    /* Block SVM__Sub                                                                                                 */

    /* Block SVM__Sub1                                                                                                */

    /* Block SVM__Sub2                                                                                                */

    /* Block SVM__Minimum1                                                                                            */


    /******************************************************************************************************************/
    /**                                               Link Block Inputs                                              **/
    /******************************************************************************************************************/

    /* Block Constant                                                                                                 */

    /* Block AutoSwitch                                                                                               */
    TAutoSwitch.In1                  = &Tpark_inv.beta;
    TAutoSwitch.Switch               = &Ttimer.out;
    TAutoSwitch.In3                  = &TConstant1.Out;

    /* Block timer                                                                                                    */

    /* Block clark                                                                                                    */
    Tclark.a                         = &(Inports.i_a);
    Tclark.b                         = &(Inports.i_b);

    /* Block Constant1                                                                                                */

    /* Block park                                                                                                     */
    Tpark.alpha                      = &Tclark.alpha;
    Tpark.beta                       = &Tclark.beta;
    Tpark.theta                      = &TNegation.Out;

    /* Block reset_qei                                                                                                */
    Treset_qei.enable                = &Ttimer.out;

    /* Block AutoSwitch1                                                                                              */
    TAutoSwitch1.In1                 = &Tpark_inv.alpha;
    TAutoSwitch1.Switch              = &Ttimer.out;
    TAutoSwitch1.In3                 = &TConstant.Out;

    /* Block park_inv                                                                                                 */
    Tpark_inv.d                      = &TConstant6.Out;
    Tpark_inv.q                      = &TConstant5.Out;
    Tpark_inv.theta                  = &(Inports.Inport);

    /* Block Constant5                                                                                                */

    /* Block clark_inv                                                                                                */
    Tclark_inv.alpha                 = &TAutoSwitch1.Out;
    Tclark_inv.beta                  = &TAutoSwitch.Out;

    /* Block Negation                                                                                                 */
    TNegation.In                     = &(Inports.Inport);

    /* Block Constant6                                                                                                */

    /* Block SVM__Maximum                                                                                             */
    TSVM__Maximum.In1                = &Tclark_inv.a;
    TSVM__Maximum.In2                = &Tclark_inv.b;

    /* Block SVM__Gain                                                                                                */
    TSVM__Gain.In                    = &TSVM__Sub1.Out;

    /* Block SVM__Gain1                                                                                               */
    TSVM__Gain1.In                   = &TSVM__Sub.Out;

    /* Block SVM__Add                                                                                                 */
    TSVM__Add.In1                    = &TSVM__Maximum1.Out;
    TSVM__Add.In2                    = &TSVM__Minimum1.Out;

    /* Block SVM__Gain2                                                                                               */
    TSVM__Gain2.In                   = &TSVM__Sub2.Out;

    /* Block SVM__Gain3                                                                                               */
    TSVM__Gain3.In                   = &TSVM__Add.Out;

    /* Block SVM__Maximum1                                                                                            */
    TSVM__Maximum1.In1               = &TSVM__Maximum.Out;
    TSVM__Maximum1.In2               = &Tclark_inv.c;

    /* Block SVM__Minimum                                                                                             */
    TSVM__Minimum.In1                = &Tclark_inv.a;
    TSVM__Minimum.In2                = &Tclark_inv.b;

    /* Block SVM__Sub                                                                                                 */
    TSVM__Sub.Plus                   = &Tclark_inv.c;
    TSVM__Sub.Minus                  = &TSVM__Gain3.Out;

    /* Block SVM__Sub1                                                                                                */
    TSVM__Sub1.Plus                  = &Tclark_inv.a;
    TSVM__Sub1.Minus                 = &TSVM__Gain3.Out;

    /* Block SVM__Sub2                                                                                                */
    TSVM__Sub2.Plus                  = &Tclark_inv.b;
    TSVM__Sub2.Minus                 = &TSVM__Gain3.Out;

    /* Block SVM__Minimum1                                                                                            */
    TSVM__Minimum1.In1               = &TSVM__Minimum.Out;
    TSVM__Minimum1.In2               = &Tclark_inv.c;

    /******************************************************************************************************************/
    /**                                                 Link Outports                                                **/
    /******************************************************************************************************************/
    Outports.pOutport                 = &TSVM__Gain.Out;
    Outports.pOutport1                = &TSVM__Gain2.Out;
    Outports.pdebug_i_alpha           = &Tclark.alpha;
    Outports.pOutport2                = &TSVM__Gain1.Out;
    Outports.pdebug_i_beta            = &Tclark.beta;
    Outports.pdebug_id                = &Tpark.d;
    Outports.pdebug_iq                = &Tpark.q;

    /******************************************************************************************************************/
    /**                                           Run Block Init Functions                                           **/
    /******************************************************************************************************************/
    Constant_FiP16_Init(&TConstant);
    AutoSwitch_FiP16_Init(&TAutoSwitch);
    timer_INT16_Init(&Ttimer);
    clark_INT16_ASM_Init(&Tclark);
    Constant_FiP16_Init(&TConstant1);
    park_INT16_ASM_Init(&Tpark);
    reset_qei_INT16_Init(&Treset_qei);
    AutoSwitch_FiP16_Init(&TAutoSwitch1);
    park_inv_INT16_ASM_Init(&Tpark_inv);
    Constant_FiP16_Init(&TConstant5);
    clark_inv_INT16_ASM_Init(&Tclark_inv);
    Negation_FiP16_Init(&TNegation);
    Constant_FiP16_Init(&TConstant6);
    Maximum_FiP16_Init(&TSVM__Maximum);
    Gain_FiP16_Init(&TSVM__Gain);
    Gain_FiP16_Init(&TSVM__Gain1);
    Add_FiP16_Init(&TSVM__Add);
    Gain_FiP16_Init(&TSVM__Gain2);
    Gain_FiP16_Init(&TSVM__Gain3);
    Maximum_FiP16_Init(&TSVM__Maximum1);
    Minimum_FiP16_Init(&TSVM__Minimum);
    Sub_FiP16_Init(&TSVM__Sub);
    Sub_FiP16_Init(&TSVM__Sub1);
    Sub_FiP16_Init(&TSVM__Sub2);
    Minimum_FiP16_Init(&TSVM__Minimum1);
    Scope_Main_Init(&TScope);
}

/**********************************************************************************************************************/
/**                                            Run Block Update Functions                                            **/
/**********************************************************************************************************************/
void X2C_Update(void)
{
    X2C_Update_1();

}

/* X2C_Update for blocks with 1*Ts                                                                                    */
void X2C_Update_1(void)
{
    park_inv_INT16_ASM_Update(&Tpark_inv);
    timer_INT16_Update(&Ttimer);
    AutoSwitch_FiP16_Update(&TAutoSwitch);
    AutoSwitch_FiP16_Update(&TAutoSwitch1);
    clark_inv_INT16_ASM_Update(&Tclark_inv);
    Negation_FiP16_Update(&TNegation);
    Maximum_FiP16_Update(&TSVM__Maximum);
    Minimum_FiP16_Update(&TSVM__Minimum);
    Maximum_FiP16_Update(&TSVM__Maximum1);
    Minimum_FiP16_Update(&TSVM__Minimum1);
    clark_INT16_ASM_Update(&Tclark);
    Add_FiP16_Update(&TSVM__Add);
    park_INT16_ASM_Update(&Tpark);
    reset_qei_INT16_Update(&Treset_qei);
    Gain_FiP16_Update(&TSVM__Gain3);
    Sub_FiP16_Update(&TSVM__Sub);
    Sub_FiP16_Update(&TSVM__Sub1);
    Sub_FiP16_Update(&TSVM__Sub2);
    Gain_FiP16_Update(&TSVM__Gain);
    Gain_FiP16_Update(&TSVM__Gain1);
    Gain_FiP16_Update(&TSVM__Gain2);
    Scope_Main_Update(&TScope);
}

