// This file was generated by createCFunction.sci on 24-02-2016 14:46

// Computational function for X2C block park_inv

#define SCILAB_SIM_FILE /* mark this file as Scilab simulation file */

/* include Scicos / Xcos headers */
#include <scicos.h>
#include <scicos_block4.h>
#include <scicos_malloc.h>
#include <scicos_free.h>
#include <Simulation_PortConversion.h>
//#define DEBUG // uncomment to enable debugging
#ifdef DEBUG
    #include <stdio.h>
#endif

/* include block implementation */
#include <park_inv_INT16_ASM.h>
#include <park_inv_INT16_ASM.c>

/* */
#define BLOCK_ERROR_INPUT_OUT_OF_DOMAIN (-1)
#define BLOCK_ERROR_SINGULARITY (-2)
#define BLOCK_ERROR_INTERNAL (-3)
#define BLOCK_ERROR_CANNOT_ALLOCATE_MEMORY (-16)

/* */
void x2c_park_inv_INT16_ASM_C(scicos_block* block, scicos_flag flag);
static void x2c_park_inv_INT16_ASM_C__OutputUpdate(scicos_block* block);
static void x2c_park_inv_INT16_ASM_C__StateUpdate(scicos_block* block);
static void x2c_park_inv_INT16_ASM_C__Initialization(scicos_block* block);
static void x2c_park_inv_INT16_ASM_C__Ending(scicos_block* block);


void x2c_park_inv_INT16_ASM_C(scicos_block* block, scicos_flag flag) {
    /*
     * This function will be called by Xcos
     */
    switch (flag) {
        case DerivativeState:  /* 0 */
        {
            break;
        }
        case OutputUpdate:     /* 1 */
        {
            x2c_park_inv_INT16_ASM_C__OutputUpdate(block);
            break;
        }
        case StateUpdate:      /* 2 */
        {
            x2c_park_inv_INT16_ASM_C__StateUpdate(block);
            break;
        }
        case OutputEventTiming: /* 3 */
        {
            break;
        }
        case Initialization:   /* 4 */
        {
            x2c_park_inv_INT16_ASM_C__Initialization(block);
            break;
        }
        case Ending:           /* 5 */
        {
            x2c_park_inv_INT16_ASM_C__Ending(block);
            break;
        }
        case ReInitialization: /* 6 */
        {
            break;
        }
        case ContinousPropertiesUpdate: /* 7 */
        {
            break;
        }
        case ZeroCrossing:     /* 9 */
        {
           break;
        }
        default:     /* Jacobian (v5.5.0) or Residute (v5.4.1) or something else */
        {
           break;
        }
    }
}


static void x2c_park_inv_INT16_ASM_C__set_parameter(scicos_block* block, PARK_INV_INT16_ASM *blockParam) {
    int *paramI;
    double *paramR;
    PARK_INV_INT16_ASM *pTpark_inv_INT16_ASM;
    
    /* *** */
    paramI = GetIparPtrs(block);  /* integer parameters  */
    paramR = GetRparPtrs(block);  /* real parameters     */
    pTpark_inv_INT16_ASM = GetWorkPtrs(block);
}


static void x2c_park_inv_INT16_ASM_C__Initialization(scicos_block* block) {
    PARK_INV_INT16_ASM *pTpark_inv_INT16_ASM;

    /* Declaration of inports */
    double *inport_d_p;
    int16 inport_d;
    double *inport_q_p;
    int16 inport_q;
    double *inport_theta_p;
    int16 inport_theta;

    /* Declaration of outports */
    double *outport_alpha;
    double *outport_beta;

    /* *** */
    pTpark_inv_INT16_ASM = scicos_malloc(sizeof(PARK_INV_INT16_ASM));
    GetWorkPtrs(block) = pTpark_inv_INT16_ASM;
    x2c_park_inv_INT16_ASM_C__set_parameter(block, pTpark_inv_INT16_ASM);

    /* Assignment of inports */
    inport_d_p = GetInPortPtrs(block, 1);
    inport_d = convert_double_to_Q15(*inport_d_p);
    pTpark_inv_INT16_ASM->d = &inport_d;
    inport_q_p = GetInPortPtrs(block, 2);
    inport_q = convert_double_to_Q15(*inport_q_p);
    pTpark_inv_INT16_ASM->q = &inport_q;
    inport_theta_p = GetInPortPtrs(block, 3);
    inport_theta = convert_double_to_Q15(*inport_theta_p);
    pTpark_inv_INT16_ASM->theta = &inport_theta;

    /* Assignment of parameter arrays */

    /* Initialization */
    park_inv_INT16_ASM_Init(pTpark_inv_INT16_ASM);

    /* Assignment of outports */
    outport_alpha = GetOutPortPtrs(block, 1);
    *outport_alpha = convert_Q15_to_double(pTpark_inv_INT16_ASM->alpha);
    outport_beta = GetOutPortPtrs(block, 2);
    *outport_beta = convert_Q15_to_double(pTpark_inv_INT16_ASM->beta);
}


static void x2c_park_inv_INT16_ASM_C__Ending(scicos_block* block) {
    PARK_INV_INT16_ASM *pTpark_inv_INT16_ASM;
    pTpark_inv_INT16_ASM = GetWorkPtrs(block);
    scicos_free(pTpark_inv_INT16_ASM);
}


static void x2c_park_inv_INT16_ASM_C__StateUpdate_f(scicos_block* block) {
/* Do nothing, calling of update function and writing to outputs is done in OutputUpdate */
}


static void x2c_park_inv_INT16_ASM_C__StateUpdate(scicos_block* block) {
    if (GetNevIn(block) > 0) {
        /*
        * GetNevIn(block) returns -1 in in case this function was called due to an internal zero-crossing.
        * GetNevIn(block)  ... activation index
        */
        x2c_park_inv_INT16_ASM_C__StateUpdate_f(block);
    }
}


static void x2c_park_inv_INT16_ASM_C__OutputUpdate(scicos_block* block) {
    PARK_INV_INT16_ASM *pTpark_inv_INT16_ASM;

    /* Declaration of inports */
    double *inport_d_p;
    int16 inport_d;
    double *inport_q_p;
    int16 inport_q;
    double *inport_theta_p;
    int16 inport_theta;

    /* Declaration of outports */
    double *outport_alpha;
    double *outport_beta;

    /* *** */
    pTpark_inv_INT16_ASM = GetWorkPtrs(block);

    /* Assignment of inports */
    inport_d_p = GetInPortPtrs(block, 1);
    inport_d = convert_double_to_Q15(*inport_d_p);
    pTpark_inv_INT16_ASM->d = &inport_d;
    inport_q_p = GetInPortPtrs(block, 2);
    inport_q = convert_double_to_Q15(*inport_q_p);
    pTpark_inv_INT16_ASM->q = &inport_q;
    inport_theta_p = GetInPortPtrs(block, 3);
    inport_theta = convert_double_to_Q15(*inport_theta_p);
    pTpark_inv_INT16_ASM->theta = &inport_theta;

    /* Assignment of parameter arrays */

    /* Update */
    park_inv_INT16_ASM_Update(pTpark_inv_INT16_ASM);

    /* Assignment of outports */
    outport_alpha = GetOutPortPtrs(block, 1);
    *outport_alpha = convert_Q15_to_double(pTpark_inv_INT16_ASM->alpha);
    outport_beta = GetOutPortPtrs(block, 2);
    *outport_beta = convert_Q15_to_double(pTpark_inv_INT16_ASM->beta);
}


